isofixer/urls.py
from django.contrib import admin
from django.urls import path, include

# path-se refera la extensia pe care o primeste url-ul pentru a merge pe alte cai(paths), ex: home, sign-in, etc.
urlpatterns = [
    path('admin/', admin.site.urls),  # admin - e path-ul de admin
    path('', include("isofixer_app.urls")),  # leaga toate path-urile de fisierul de urls din _app

]

isofixer_app/urls.py
from django.urls import path
from . import views  # importa fisierul views din directorul de _app; face legatura cu views

urlpatterns = [
    # path("", views.index, name="index"),
    # path("<str:name>", views.index, name="index"),  # A din isofixer_app/views.py pt linia 6
    path("<int:id>", views.index, name="index"),  # pentru base, home, and so on
    # path("v1/", views.v1, name="view 1"),  - B din isofixer_app/views.py
    path("", views.home, name="home"),
    path("create/", views.create, name="create"),

]

isofixer_app/models.py
from django.db import models


# Create your models here.

class ToDoList(models.Model):
    name = models.CharField(max_length=200)

    def __str__(self):
        return self.name


class Item(models.Model):
    todolist = models.ForeignKey(ToDoList, on_delete=models.CASCADE)
    text = models.CharField(max_length=300)
    complete = models.BooleanField()

    def __str__(self):
        return self.text


class Car(models.Model):
    todolist = models.ForeignKey(ToDoList, on_delete=models.CASCADE)
    car_type = models.CharField(max_length=300)
    complete = models.BooleanField()

    def __str__(self):
        return self.car_type

isofixer_app/forms.py
from django import forms

class CreateNewList(forms.Form):
    name = forms.CharField(label="Name", max_length=200)
    check = forms.BooleanField()

isofixer_app/views.py
from django.shortcuts import render
from django.http import HttpResponse
from isofixer_app.models import *
from .forms import CreateNewList

# Create your views here.


# def index(response):
#     return HttpResponse("<h1>welcome to your ISO Fixer!</h1>")


from isofixer_app.models import ToDoList


# def index(response, name):  # A din isofixer_app/urls.py
#     ls: ToDoList = ToDoList.objects.get(name=name)
#     items = ls.car_set.get(id=1)
#     return HttpResponse(f"<h1>{ls.name}<p>{str(items.car_type)}</p></h1>")


# '''B din isofixer_app/urls.py - ASTA E BUSIT RAU!'''
# def v1(response, car_type):
#     ls = ToDoList.objects.get(car_type=car_type)
#     car = ls.car_set.get(id=1)
#     return HttpResponse(f"<h1>{{ls.car}} {{str(car.car_type}}</h1>")

# asta il facem pentru base si home and so on. linia 16 va fi inlocuita de functia asta.
# def index(response, id):  # A index pentru base.html - asta e un exemplu care va afisa numele listei de la poz indicata in url/poz indicata
#     ls = ToDoList.objects.get(id=id)
#     return render(response, "isofixer_app/base.html", {"name": ls.name})

def index(response, id):  # A index pentru base.html
    ls = ToDoList.objects.get(id=id)
    return render(response, "isofixer_app/list.html", {"ls": ls})


# pentru path-ul din isofixer_app\urls - linia 8 cream o functie noua:
def home(response):
    # return render(response, "isofixer_app/home.html", {"name": "test"}) - ne arata "test" pe home page (url-ul fara /ceva)
    return render(response, "isofixer_app/home.html", {})


def create(response):
    form = CreateNewList()
    return render(response, "isofixer_app/create.html", {'form':form})

templates/isofixer_app/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title> {% block title %}Iso Fixer{% endblock %}</title>
</head>
<body>

<p>Base Template</p>

{# content block care poate fi suprascris din celelalte .html-uri care au exteds - vezi home.html #}
<div id="content" , name="content">
    {# acest div nu face parte din block, are aici rol doar de a putea identifica ulterior segmentul acesta#}

    {% block content %}
    {% endblock %}

</div>
<p>{{ name }}</p>

</body>
</html>

templates/isofixer_app/create.html
{% extends "isofixer_app/base.html" %}

{% block title %}Create new list {% endblock %}

{% block content %}
    Create page
    <form method="post" action="/create/">
        {% csrf_token %}
        {{ form.as_p }}
    <button type="submit", name="save">Create New</button>

    </form>
{% endblock %}

templates/isofixer_app/home.html
{% extends 'isofixer_app/base.html' %}

{% block content %}
<h1>Home page</h1>

{% endblock %}

templates/isofixer_app/list.html
{% extends 'isofixer_app/base.html' %}

{% block title %}View list{% endblock %}

{% block content %}
    <h1>{{ ls.name }}</h1>
    <ul>
        {% for item in ls.item_set.all %}
            {% if item.complete == True %}
                <li>{{ item.text }} - Complete</li>
            {% else %}
                <li>{{ item.text }} - Incomplete</li>
            {% endif %}
        {% endfor %}
    </ul>
{% endblock %}